#include <emsg: see ... '~$ sh aaa.sh.c -h'   (other opt:no/-m/-w/)>	/*
C='^[#]SH_'			;O=${0##*[/]};R=`dirname $0`/;R0=$R$O;Re=eval\ ;R=$R${O%%.*}
O=${0##*.};Rs=$R.$O;Rm=$R.tmp.$O;Rh=$R.h;R=$Rs$Rh$Rm;Rp='printf %s\n ';Rc=:;O="
";[ -z "${R##*$R0*}" ]&&$Rp"$0:NGext"&&exit 1;R='sed -ne ';Cm=$R'"/[E]ND/!d;: l
n;p;b l"<$R0>$Rm;$Rp"$Rm"';Rw=$R'"/$C$R/!d;: l;n;/${C}ED/q;p;b l"<$R0';Cw="(R=LS
$Rw;$Rw>&3;R=HD;$Rw;R=SC;$Rw>&3)"'>$Rh 3>$Rs;$Rp"$Rh $Rs"';RB=$($R"s/${C}OP//p"\
<$R0|(F=mw;while read -r a b;do B=${a%:};F=`$Rp"$F"|$R"s#$B:*##;p"`${a%_};$Rp"
C$B=\$(cat<<'E'$O$b${O}E$O)";done;$Rp"R1=$F"));$Re"$RB";while getopts $R1 R;do
case $R in \?)exit 1;;*)$Re"O$R=\$OPTARG";Rc=$Rc$O`$Re'$Rp"$C'$R\"`;;esac;done
[ "$Rc" = : ]&&Rc=$Cm;shift $((OPTIND-1));$Re"$C_$O$Rc";exit #END  GPLv3+*/

#SH_LS
#!/bin/sh
:<< 'E==='
/* Copyright (C) 2023 momi-g

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
E===

:<< 'E==='
#SH_doc
title=*SH_bn* section=1 repnl=\040
@name *SH_bn*
@_brief expand bash bindcmd 'undo' to 'undo/redo'
@_syno
	*SH_bn* [-hHV]
	*SH_bn* [-Q]
@tl_dr
		@(code)--@
	~$ *SH_bn* -Q #>> output corecode
	
	#--- ~/.bashrc
	(..your ini...)
	(..copy the '-Q' output funcs)
	  #--prepare callback
	bind '"\C-org_undo": undo ' #>> need the readline built-in 'undo'
	bind -x '"\C-bur_undo": bur_undo'
	bind -x '"\C-bur_undo_sub": bur_undo_diff'
		
	  #--main_keybind 'undo/redo'
	bind '"\b": "\C-bur_undo\C-org_undo\C-bur_undo_sub" ' #>> \b==ctrl-bksp
	bind -x '"\C-r": bur_redo'	#>> ctrl-r == redo
	#---
	
	#--test
	~$ hello,wor(ld)	#-- input str then del 2char (ld)
	~$ hello,worl	#-- undo: ctrl-bs
	~$ hello,world	#-- undo: ctrl-bs
	~$ hello,worl	#-- redo: ctrl-r
	~$ hello,wor	#-- redo: ctrl-r
		@()--@
@_opt
		@(list_o)
	-hHV: help, version
	-Q: output corecode
		@()
@_desc
	bash 'readline' has 'undo' cmd for keybind but 'redo' doesnt.
	this script provides 'undo/redo' functions. --

@exit_status suc/fail == 0/not0 (raise err/emsg if fatal) --
@notes
 rollback history size is 100, hardcoded. --
 this script uses names 'bur_XX' for var/funcs --
@compat	posix-shell
@copyright	Copyright (C) 2023 Momi-g, AGPLv3+
@_ver 2023-06-25 v1.0.0 (2023-06-25 v1.0.0)
@_see bash(1), readline(3)
#SH_docE
E===
#SH_ED

#SH_HD
#SH_ED

#SH_SC
f_vlv_def(){
 f_err(){ echo "*SH_bn*:---err. $1" && exit ${2:-1};}>/dev/stderr
 f_srr(){ while :;do echo "*SH_bn*:---errstop. $*"; sleep 1000;done; }>/dev/stderr
 f_wrr(){ echo "*SH_bn*:---msg. $*";} >/dev/stderr
 f_drr(){ echo "*SH_bn*:---dbg. $*";} >/dev/stderr
 f_vrr(){ echo "*SH_bn*:---val";echo "$(s_val "$@")";} >/dev/stderr
 f_VRR(){ echo "*SH_bn*:---val";echo "$(s_val "$@")";} >/dev/stderr
 s_val()(
 	[ "${1##@*}" = "" ] && echo "$@" && return
 	for _vbg; do
 	set -- "$_vbg" "$(eval 'printf "%s@" "$'"$_vbg"'"')"
 	printf '%s#%s:%s;\n' "$1" $((${#2}-1)) "${2%?}"
 	done
 )
 _f_nrr(){
 	tm=5000
 	[ "$2" != "" ] && tm="$2"
 	command -v notify-send >/dev/null 2>&1 || return
 	notify-send "(*SH_bn*) $1" -t "$tm"
 }
 f_NRR(){ _f_nrr "$@"; echo "*SH_bn*:---msg. $*">/dev/stderr; }
 f_nrr(){ _f_nrr "$@"; }
}
f_vlv_def
f_vlv(){
	[ "$1" = 0 ] && {
		f_err(){ exit ${2:-1}; }
		f_nrr(){ :; }
#		f_drr(){ :; }
		f_wrr(){ :; }
		f_vrr(){ :; }
	}
	[ "$1" = 1 ] && {
#		f_drr(){ :; }
#		f_wrr(){ :; }
		f_vrr(){ :; }
	}	
	[ "$1" = 2 ] && :
}
pcho(){ printf '%s\n' "$@";}

#SH_TSS
eq(){ _eq "$@"; }
nq(){ _neq "$@"; }

test_0(){
	# f_grr "test start: needs 30s..." 8000
	eq 1 1
}
#SH_TSE

#SH_TSS
test_msg(){
	hello="1_hello"
	f_wrr hello;	_suc
	f_vrr hello; _suc
	f_nrr hello; _suc
	f_drr hello; _suc
	f_NRR hello; _suc
	
	(f_err hello 2)
	eq "$?" 2
	(f_err hello)
	eq "$?" 1

	echo hellokko | f_wrr; _suc
	echo hellokko | f_nrr; _suc
	echo hellokko | f_NRR; _suc
	(echo helloo| f_err)
	eq "$?" 1

 f_vlv 2
	buf=$(f_wrr hello 2>&1)
	nq "$buf" ''

	buf=$(f_vrr hello 2>&1)
	nq "$buf" ''
	
 f_vlv 1
	buf=$(f_wrr hello 2>&1)
	nq "$buf" ''

	buf=$(f_nrr hello 2>&1)
	eq "$buf" ''
	buf=$( (f_err hello 3)2>&1)
	eq $? 3
	nq "$buf" ''
	buf=$( f_vrr hello 2>&1)
	eq "$buf" ''

 f_vlv 0
	buf=$(
	f_wrr hellod 2>&1
	f_vrr hello 2>&1
	f_nrr hello 2>&1
	(f_err hello 2 2>&1)
	:
	) 
	eq "$buf" ''

	buf=$(f_drr hello 2>&1)
	echo "__ $buf"
	nq "$buf" ''

	buf=$(f_NRR hello 2>&1)
	nq "$buf" ''

	echo "ok: test_msg" >/dev/stderr
}
#SH_TSE

f_usage(){
cat << 'E==='
HowTo (*SH_bn*, provides undo/redo for bash keybind)
opt: -hHV(help,ver), -Q(uine, output corecode)
------
 #--(edit .bashrc)
 (..your bash ini..)
 (..copy the '~$ *SH_bn* -Q' output funcs..)	
 
 bind '	"\C-u": undo '	#>> need org readline 'undo' API
 bind -x ' "\C-aa": bur_undo '
 bind -x ' "\C-bb": bur_undo_diff '
	
	#--main undo/redo keybinds
 bind ' "\b": "\C-aa\C-u\C-bb" '
	#>> C-bksp ==  "bur_undo; undo(org); bur_undo_diff"
 bind -x ' "\C-r": bur_redo'
 #---
 
 ~$ hell(o)	#>> input str then del the last 'o' char
 ~$ hello	#>> ctrl-bksp (undo)
 ~$ hell	#>> ctrl-r (redo)

...see '-H' for details
E===
	exit 0
}

f_usageH(){
	cat <<- 'E==='|sed -e'1d;$d'
	#SH_rf* *SH_bn*.1.txt
	E===
	exit 0
}

f_verinfo(){
		cat <<- 'E==='
	*SH_bn* *SH_ver*
	*SH_copy* 
		E===
	exit 0
}

f_sample(){
cat << 'E==='
	:
E===
	exit 0
}

f_quine()(
	cat <<'E==='
#---*SH_bn*:  Copyright (C) 2023 Momi-g, AGPLv3+

bur_mdx_=100	#>> max recall == 100
bur_cdx_=0

#--strbuf
# bur_sarr_1='hello'
# bur_sarr_2='hell'
# ...
# bur_sarr_5=(none)	#>> skip save

bur_undo_diff(){
	eval '[ "$bur_sarr_'$bur_cdx_'" != "$READLINE_LINE" ]' && return

		#-- undo makes no change >> reset
	eval 'unset bur_sarr_'$bur_cdx_
	bur_cdx_=$((bur_cdx_-1))
	[ "$bur_cdx_" -le 0 ] && bur_cdx_="$bur_mdx_"
}

bur_undo(){
	bur_cdx_=$((bur_cdx_+1))
	[ "$bur_cdx_" -gt "$bur_mdx_" ] && bur_cdx_=1
	eval 'bur_sarr_'$bur_cdx_'="$READLINE_LINE"'
}

bur_redo(){
		#-- use subshell for save global ENV
	(
		buf=bur_sarr_$bur_cdx_
		cmd=': "${'$buf'?}"'	#>> ~= unset, ~$ : "${bur_sarr_1?}" >> nullcmd
		eval "$cmd" || exit 1
	) 2>/dev/null || return

		#-- rollback
	eval 'READLINE_LINE="$bur_sarr_'$bur_cdx_'"'
	bur_cdx_="$((bur_cdx_-1))"
	[ "$bur_cdx_" -le 0 ] && bur_cdx_="$bur_mdx_"
}

#---*SH_bn*: end
E===
)

#SH_TSS
test_q(){
	cmd="*SH_bn*"
	./$cmd -Q | grep bur_redo
	_suc
	
	cmd=$(./$cmd -Q)
	eval "$cmd"

	bur_redo
	_eq $bur_cdx_ 0

	bur_redo
	_eq $bur_cdx_ 0
	
	READLINE_LINE=hello
	bur_undo
	_eq $bur_cdx_ 1
	
	READLINE_LINE=world
	bur_redo
	_eq $bur_cdx_ 100
	_eq "$READLINE_LINE" hello

		#--limit test
	bur_redo
	_eq $bur_cdx_ 100
	_eq "$READLINE_LINE" hello

		#--multiple undo/redo test
	READLINE_LINE=hel
	bur_undo
	_eq $bur_cdx_ 1
	
	READLINE_LINE=he
	bur_undo
	_eq $bur_cdx_ 2

	READLINE_LINE=h
	bur_undo
	_eq $bur_cdx_ 3

		#---
	bur_redo
	_eq $bur_cdx_ 2
	_eq "$READLINE_LINE" h
	
	bur_redo
	_eq $bur_cdx_ 1
	_eq "$READLINE_LINE" he

	bur_redo
	_eq $bur_cdx_ 100
	_eq "$READLINE_LINE" hel

	echo "ok: test_stk"
}
#SH_TSE

# xipath:  Copyright (C) 2022 Momi-g, AGPLv3+
xipath()(
	[ "${1#-[Pf]}" = "" ] && shift
	c="$PWD"
	b=${1##*/}
	d=${1%"$b"}
	[ "${d#./}" = "" ] && d="$c"/
	[ "$d" = "../" ] && d="${c%/*}"/
	s="$d$b"
	while [ -L "$s" ];do
		buf="$s: symbolic link to @"	#--format for posix locale
		ss=$(LC_ALL=C file -h "$s"|cut -b ${#buf}-;echo @)
		ss="${ss%??}"
		[ "${ss#/}" != "$ss" ] && s="$ss" || s="${s%/*}/$ss"
	done
	buf=$(printf '%s@' "$s"|sed -e "s/[*?[]/\\&/g")
	find -L . -path "${buf%?}" -type l|grep .&&exit 1		#--see posix 'find'
	cd "${s%/*}/"; d="$(pwd -P)/"
	echo "$d${s##*/}@"
)
# xipath: ---end
cdir_=$(pwd)
sdir_=$(xipath "$0")
sdir_=$(dirname "$sdir_")
export PATH="$sdir_:$PATH"
hash -r

#-- ~$ wmdd -a 4
*SH_bn*(){
		while getopts ":hHVQ" c && xx=1; do
		while [ "$xx" = 1 ]&&xx=0; do case "$c" in	#-- xx: fall-through magic		
	# (h) echo 123; xx=1;c=H	;;		#--fall_sample
	(h) f_usage; exit	;;
	(H) f_usageH; exit	;;
	(V) f_verinfo; exit	;;
	(Q) f_quine; exit ;;
	([?:]) f_err "bad opt: $v: $*" ;;	
		esac; done; done; shift $(($OPTIND-1))

	exit
}

*SH_bn*_main(){ *SH_bn* "$@"; }
*SH_bn*_main "$@" || exit	#SH_MAIN

#SH_TSS
test_cmd(){
	cmd="*SH_bn*"
	./$cmd -h;	_suc 1
	./$cmd -H;	_suc 2
	./$cmd -V;	_suc 3
	./$cmd -Q;	_suc 4

	echo "ok: test_cmd"
}
#SH_TSE

#SH_TSS
test_w_(){
	awkcode='
function f_impl(s,	a,b,arr){
	return s
}

function f_sort(arr,	mdx,suc){
	for(i in arr){mdx++}
	suc=1; while(suc) {suc=0; for(i=2;i<=mdx;i++) {
	if(arr[i-1]>arr[i]) {buf=arr[i]; arr[i]=arr[i-1] ;arr[i-1]=buf; suc=1; }
	} }
}
function f_uniq(arr, 	mdx,bi,brr){
	for(i in arr){mdx++}
	for(i=1;i<=mdx;i++){ if(arr[i] != brr[bi+0]){ bi++; brr[bi]=arr[i] } }
	split("",arr)
	for(i in brr){ arr[i]=brr[i] }
}
function _runtest(){	#"function _runtest()" >> "0" for ignore but save testcode
	eq(10, 10)
	return
	
	s="{+s+c+l+m1+m2+m3+m4+m5}"
	q="+Control+Lock+Mod1+Mod2+Mod3+Mod4+Mod5+Shift "
	s=f_impl(s)
	eq(s, q)
}
'
awk '
BEGIN{
	_runtest()
	printf("fail/all: %s/%s\n", test_fail+0, test_all+0) > "/dev/stderr"
	exit(0)
}

#*SH_rf* 0 awktool.awk

'"$awkcode"
	nq 1 0
}
#SH_TSE

:<<'E==='
change log
--
2023-06-25 Momi-g	<dmy@dmy.dmy>

	* *SH_bn*(all): init v1.0.0

E===
#SH_ED

#SH_OP _ a=`sed -ne "/${C}DF/!d;:l;n;/${C}DE/q;p;bl"<$R0`;eval "$a";set +e	#*/
#SH_OP h $p"-tsbS:test/eg/.o/.so -LMP:leak,mem,prof -f:funcs -o:bldout	GPLv3+"	 #*/
#SH_OP f sed -ne "/${C}DF/q;/;/d;/^[a-z].*)/p"<$R0|tr -d ' \t'|grep -F '()' #*/
#SH_OP t $e"$CW";ftt "$@";$p"bash --posix $Ox $tf"|fvd
#SH_OP T $e"$CW";ftt "$@";$p"dash $Ox $tf"|fvd
#SH_OP i $e"$Cb";$p'shellcheck -s sh -e SC2046,SC2086,SC2004,SC2154,SC2015,SC2016,SC2006,SC2030,SC2031,SC2145 $bn.sh'|fv
#SH_OP s fgr0 "${C}SMP" "${C}SMPE"<$R0>eg.sh #;$p"luajit eg.lua"|fv
#SH_OP x Ox="-x";fvd(){ fv 2>&1|tee dbg.txt; } 
#SH_OP v Ov="-v2"

#SH_OP b $e"$CW"
#SH_OP W fpp;$e"$Cm$O$Cw">/dev/null;fborn;chmod 755 $bn $bn.sh;$e"$Cs";$p"$bn $Rs $Rh $tf"	#*/
#SH_OP o $e"$CW";$p'fman $Rh 1'|fv		#*/

#SH_DF
#-- noob
fman()( $p"fgr0 '${C}doc' '${C}docE'<$1|amn >$bn.$2
mandoc -Thtml <$bn.$2 >$bn.$2.html
man -Tutf8 -l -<$bn.$2|sed -e 's/.`printf \"\\b\"`//g'>$bn.$2.txt
"|fv
#(echo '.mso ja.tmac';cat $bn.$2)|man -Tutf8 -l -|sed -e 's/.`printf \"\\b\"`//g'>$bn.$2.txt"|fv
)

#-- vars
bn=`basename ${Rs%.*}`; tf=${Rs%/*}/${bn}.ts.${Rs##*.}; e="eval "; p="$Rp"
#-- mod
fv()(while read -r a;do $e"cat<<E$O# $a${O}E"|sed -e 's@-L.*-L[^ ]*@-L(omit)@g'>/dev/stderr;$e"$a";done)
fvd(){ fv; }

fbn()(sed -e "s@\*${C##*]}bn\*@$bn@g"|frv|fry|flit|frf)
fsn()(tr -s ' \t' '\n')
fsl()(tr -s '\n' ' ')
fu()(fsn|sort -u)
fU()(fu|fsl;$p)

fgr()(sed -e "/$1/!d;:l;/$2/{p;d};n;bl")	#切出
fgr0()(sed -ne "/$1/!d;:l;n;/$2/d;p;bl")	#抜き切出
fgR()(sed -ne "/$1/bl;p;d;:l;n;/$2/d;bl")	#切すて
fg()(sed -ne "s/.*${C##*]}co\*\([^*]*\).*$/\1/p" "$@"|fsn|awk '!a[$0]{a[$0]=1;print}'|fsl)

#-- longcmd
frf()(
# *sh_rf* 0 a.txt b.txt ...でcat纏めて出力 top0でsrcinfoは無し出力
awk -v tg="${C##*]}rf" -v cs='#' -v ce='' 'index($0,tg){
s=substr($0, index($0,tg)+length(tg)+1);split(s, a)
m="[ -f \"%s\" ]&&(echo \"%s--copyfrom %s %s\";cat \"%s\";echo \"%s--copyend %s %s\")"
mm="[ -f \"%s\" ]&&(_=\"%s%s%s\";cat \"%s\";_=\"%s%s%s\")"
for(i=1;i in a;i++){v=a[i];if(v==0){m=mm;continue};system(sprintf(m,v,cs,v,ce,v,cs,v,ce))}
next
}
{print}'
)

frv()(buf=`awk '$1=="@_ver" {print $3;exit}'<$R0`;sed -e "s@\*${C##*]}ver\*@$buf@g")
fry()(buf=`awk '$1~ /^@license|^@copy/ {$1="";print;exit}'<$R0`;sed -e "s@\*${C##*]}copy\*@$buf@g")
flit()(sed -ne "/${C}lit/bl;p;d;:l;n;/${C}litE/d;"'s/[\]/&&/g;s/"/\\"/g;s@.*@"&\\n"@g;p;bl')

fte()(
cat > $Rm-
suite=$(cat $Rm-|awk '$1~/^test_[^(]*\(\)/{print $1}'|sed -e 's/[(].*//g'|$e"$gfn")
[ $# = 0 ] && suite="$suite $suite"|| suite="$suite $@"
suite=`$p'%s\n' "$suite"|tr '[ \t]' '\n'|sort|uniq -d|fsl`
(cat $Rs $Rm-|grep -vF "${C##*]}MAIN"
$p'[ $# = 0 ]&&set -- '"$suite"';for fc;do echo "--$fc():">/dev/stderr;$fc;done;_res')
rm -f $Rm-
)
ftt()(
[ ${#1} != 0 ] && [ "${1#[012]}" = '' ] && Ov=-v$1 && shift
shunit_m $Ov>$Rm;fte "$@"<$tf>>$Rm;mv $Rm $tf
)

fborn(){
gfn="cat -";fgr0 "${C}TSS" "${C}TSE"<$R0|fbn>$tf
fgR "${C}TSS" "${C}TSE"<$Rs|fbn|tee $Rm>$bn;mv -f $Rm $Rs;fbn<$Rh>$Rm;mv $Rm $Rh
gfn="grep -v '_$'";fgR "${C}TSS_" "${C}TSE"<$R0 |fgr0 "${C}TSS" "${C}TSE"|fbn|fte>tests.code
R0="${R0%?}"
}

fpp(){ awk "{gsub(/[*]${C##*]}ln[*]/,NR);print}"<$R0>${R0}0; R0="$R0"0; $p"${R0}"; }
#SH_DE
